diff --git a/src/xdisp.c b/src/xdisp.c
index d61d421..9df78b1 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -11208,7 +15915,9 @@ resize_echo_area_exactly (void)
 	{
 	  windows_or_buffers_changed = 42;
 	  update_mode_lines = 30;
-	  redisplay_internal ();
+      mc_redisplay_internal = 1;
+      redisplay_internal (1);
+      mc_redisplay_internal = 0;
 	}
     }
 }
@@ -11695,7 +16404,9 @@ echo_area_display (bool update_frame_p)
 	      ptrdiff_t count = SPECPDL_INDEX ();
 	      specbind (Qredisplay_dont_pause, Qt);
 	      fset_redisplay (f);
-	      redisplay_internal ();
+          mc_redisplay_internal = 2;
+          redisplay_internal (2);
+          mc_redisplay_internal = 0;
 	      unbind_to (count, Qnil);
 	    }
 	  else if (FRAME_WINDOW_P (f) && n == 0)
@@ -13374,6 +18085,19 @@ hscroll_window_tree (Lisp_Object window)
 	      else
 		pt = clip_to_bounds (BEGV, marker_position (w->pointm), ZV);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  struct display_pos *pos = &cursor_row->start;
+  ptrdiff_t charpos = CHARPOS (pos->pos);
+  bool barf_crash = (charpos < 0 || (charpos >= BUF_BEG (current_buffer) && charpos <= ZV)) ? false : true;
+  if (barf_crash)
+    return hscrolled_p;
+
+/* *************************************************************************** */
+
+
 	      /* Move iterator to pt starting at cursor_row->start in
 		 a line with infinite width.  */
 	      init_to_row_start (&it, w, cursor_row);
@@ -13615,9 +18339,17 @@ text_outside_line_unchanged_p (struct window *w,
    mini-buffer if that is in use.  */
 
 void
-redisplay (void)
+redisplay (int from_where)
 {
-  redisplay_internal ();
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p)
+    fprintf (stderr, "\nredisplay (%d)\n", from_where);
+#endif
+  mc_redisplay = from_where;
+  mc_redisplay_internal = 3;
+  redisplay_internal (3);
+  mc_redisplay_internal = 0;
+  mc_redisplay = 0;
 }
 
 
@@ -13886,8 +18618,12 @@ do { if (polling_stopped_here) start_polling ();	\
    is not necessary; currently that causes some problems.  */
 
 static void
-redisplay_internal (void)
+redisplay_internal (int from_where)
 {
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p)
+    fprintf (stderr, "\nredisplay_internal (%d)\n", from_where);
+#endif
   struct window *w = XWINDOW (selected_window);
   struct window *sw;
   struct frame *fr;
@@ -14289,6 +19025,22 @@ redisplay_internal (void)
 #ifdef HAVE_WINDOW_SYSTEM
 	      update_window_fringes (w, false);
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+      mc_remove_multiple_cursors (w);
+      mc_remove_crosshairs (w);
+
+/* *************************************************************************** */
+
+
 	      goto update;
 	    }
 	  else
@@ -14311,6 +19063,20 @@ redisplay_internal (void)
 		  && (w = XWINDOW (selected_window)) != sw)
 		goto retry;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+        if (mc_without_update_frame (w))
+          goto end_of_redisplay;
+
+/* *************************************************************************** */
+
+
 	      /* We used to always goto end_of_redisplay here, but this
 		 isn't enough if we have a blinking cursor.  */
 	      if (w->cursor_off_p == w->last_cursor_off_p)
@@ -14352,6 +19118,22 @@ redisplay_internal (void)
 		  *w->desired_matrix->method = 0;
 		  debug_method_add (w, "optimization 3");
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+      mc_remove_multiple_cursors (w);
+      mc_remove_crosshairs (w);
+
+/* *************************************************************************** */
+
+
 		  goto update;
 		}
 	      else
@@ -14732,16 +19514,36 @@ redisplay_preserve_echo_area (int from_where)
   block_buffer_flips ();
   unblock_input ();
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  struct window *w = decode_live_window (selected_window);
+  w->mc.redisplay_preserve_echo_area = from_where;
+  mc_redisplay_preserve_echo_area = from_where;
+
   if (!NILP (echo_area_buffer[1]))
     {
       /* We have a previously displayed message, but no current
 	 message.  Redisplay the previous message.  */
       display_last_displayed_message_p = true;
-      redisplay_internal ();
+      mc_redisplay_internal = 4;
+      redisplay_internal (4);
+      mc_redisplay_internal = 0;
       display_last_displayed_message_p = false;
     }
   else
-    redisplay_internal ();
+    {
+      mc_redisplay_internal = 5;
+      redisplay_internal (5);
+      mc_redisplay_internal = 0;
+    }
+
+  w->mc.redisplay_preserve_echo_area = 0;
+  mc_redisplay_preserve_echo_area = 0;
+
+/* *************************************************************************** */
+
 
   flush_frame (SELECTED_FRAME ());
   unbind_to (count, Qnil);
@@ -17296,6 +22098,16 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
   debug_method_add (w, "recenter");
 #endif
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+
+/* *************************************************************************** */
+
+
   /* Forget any previously recorded base line for line number display.  */
   if (!buffer_unchanged_p)
     w->base_line_number = 0;
@@ -17726,6 +22538,21 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
   else
     TEMP_SET_PT_BOTH (CHARPOS (opoint), BYTEPOS (opoint));
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+
+/* *************************************************************************** */
+
+
   set_buffer_internal_1 (old);
   /* Avoid an abort in TEMP_SET_PT_BOTH if the buffer has become
      shorter.  This can be caused by log truncation in *Messages*.  */
@@ -21079,6 +25906,21 @@ display_count_lines_visually (struct it *it)
 static void
 maybe_produce_line_number (struct it *it)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  bool barf_crash = (it->glyph_row == NULL
+                     || it->glyph_row->used[TEXT_AREA] == 0)
+                    ? false
+                    : true;
+  if (barf_crash)
+    return;
+
+/* *************************************************************************** */
+
+
   ptrdiff_t last_line = it->lnum;
   ptrdiff_t start_from, bytepos;
   ptrdiff_t this_line;
@@ -29759,9 +34601,32 @@ display_and_set_cursor (struct window *w, bool on,
       w->phys_cursor.vpos = vpos;
     }
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  w->mc.h = -1;
+  w->mc.fx = -1;
+  w->mc.fy = -1;
+  w->mc.glyph_flavor = NO_FLAVOR;
+  w->mc.red = -1.0;
+  w->mc.green = -1.0;
+  w->mc.blue = -1.0;
+  w->mc.posint = -1;
+
   FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
                                      new_cursor_type, new_cursor_width,
                                      on, active_cursor);
+
+  mc_multiple_cursors_portal (w, on, active_cursor);
+
+  /* The real cursor (drawn above) is gets removed by crosshairs.
+  `mc_draw_crosshairs' relies upon `w->phys_cursor.x/y/hpos/vpos' when ON. */
+  mc_crosshairs_portal (w, on, active_cursor);
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -29793,10 +34658,22 @@ update_window_cursor (struct window *w, bool on)
       if (row->reversed_p && hpos >= row->used[TEXT_AREA])
 	hpos = row->used[TEXT_AREA] - 1;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      if (!mc_crosshairs_p (w)
+          && !mc_multiple_cursors_p (w))
+        {
       block_input ();
       display_and_set_cursor (w, on, hpos, vpos,
 			      w->phys_cursor.x, w->phys_cursor.y);
       unblock_input ();
+        }
+
+/* *************************************************************************** */
+
+
     }
 }
 
@@ -32503,6 +37380,22 @@ x_intersect_rectangles (XRectangle *r1, XRectangle *r2, XRectangle *result)
 void
 syms_of_xdisp (void)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  defsubr (&Smc_activate_multiple_cursors);
+
+  defsubr (&Smc_activate_crosshairs);
+
+  defsubr (&Smc_stderr);
+
+  defsubr (&Sdebugging);
+
+/* *************************************************************************** */
+
+
   Vwith_echo_area_save_vector = Qnil;
   staticpro (&Vwith_echo_area_save_vector);
 
@@ -33440,4 +38333,4 @@ cancel_hourglass (void)
     }
 }
 
-#endif /* HAVE_WINDOW_SYSTEM */
+#endif /* HAVE_WINDOW_SYSTEM */
\ No newline at end of file
diff --git a/src/xterm.c b/src/xterm.c
index f8ea787..71f184d 100644
--- a/src/xterm.c
+++ b/src/xterm.c
@@ -1530,6 +1530,20 @@ static void x_check_font (struct frame *, struct font *);
 static void
 x_set_cursor_gc (struct glyph_string *s)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  if (s->w->mc.cursor_gc_default)
+    {
+      s->gc = s->f->output_data.x->cursor_gc;
+      return;
+    }
+
+/* *************************************************************************** */
+
+
   if (s->font == FRAME_FONT (s->f)
       && s->face->background == FRAME_BACKGROUND_PIXEL (s->f)
       && s->face->foreground == FRAME_FOREGROUND_PIXEL (s->f)
@@ -9252,6 +9266,26 @@ x_draw_hollow_cursor (struct window *w, struct glyph_row *row)
 
   /* Compute frame-relative coordinates for phys cursor.  */
   get_phys_cursor_geometry (w, row, cursor_glyph, &x, &y, &h);
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* LEGEND:
+
+-  top y == WINDOW_TO_FRAME_PIXEL_Y (w, row->y)
+
+-  bottom y == WINDOW_TO_FRAME_PIXEL_Y (w, row->y) - row->height
+
+-  h of HOLLOW_BOX_CURSOR == row->height
+   [This avoids a visible gap above/below.] */
+
+  if (w->mc.h > 0)
+    h = row->height;
+
+/* *************************************************************************** */
+
+
   wd = w->phys_cursor_width - 1;
 
   /* The foreground of cursor_gc is typically the same as the normal
@@ -9328,7 +9362,18 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row, int width, enum text
 	 invisible.  Use the glyph's foreground color instead in this
 	 case, on the assumption that the glyph's colors are chosen so
 	 that the glyph is legible.  */
-      if (face->background == f->output_data.x->cursor_pixel)
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      if (face->background == f->output_data.x->cursor_pixel
+          && !w->mc.cursor_gc_invisible_okay)
+
+
+/* *************************************************************************** */
+
+
 	xgcv.background = xgcv.foreground = face->foreground;
       else
 	xgcv.background = xgcv.foreground = f->output_data.x->cursor_pixel;
@@ -9359,6 +9404,17 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row, int width, enum text
 	  if ((cursor_glyph->resolved_level & 1) != 0)
 	    x += cursor_glyph->pixel_width - width;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+    /* Align all fake BAR_CURSOR of the VERTICAL_RULER with `opoint_x'. */
+    if (w->mc.fx > 0)
+      x = w->mc.fx;
+
+/* *************************************************************************** */
+
+
 	  x_fill_rectangle (f, gc, x,
 			  WINDOW_TO_FRAME_PIXEL_Y (w, w->phys_cursor.y),
 			  width, row->height);
@@ -9435,31 +9491,163 @@ x_draw_window_cursor (struct window *w, struct glyph_row *glyph_row, int x,
 	}
       else
 	{
-	  switch (cursor_type)
-	    {
-	    case HOLLOW_BOX_CURSOR:
-	      x_draw_hollow_cursor (w, glyph_row);
-	      break;
 
-	    case FILLED_BOX_CURSOR:
-	      draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
-	      break;
 
-	    case BAR_CURSOR:
-	      x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
-	      break;
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
 
-	    case HBAR_CURSOR:
-	      x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
-	      break;
+  struct x_display_info *dpyinfo = FRAME_DISPLAY_INFO (f);
+  Colormap cmap = FRAME_X_COLORMAP (f);
+  unsigned long original_cursor_pixel = f->output_data.x->cursor_pixel;
+  /* xterm.c/xterm.h use GC; whereas, w32term.c/w32term.h use XGCValues * */
+  GC original_cursor_gc = f->output_data.x->cursor_gc;
+  double base = 65535.0;
+  double term_red = base * w->mc.red;
+  double term_green = base * w->mc.green;
+  double term_blue = base * w->mc.blue;
+  int int_red = XFIXNUM (Ftruncate (make_float (term_red), Qnil));
+  int int_green = XFIXNUM (Ftruncate (make_float (term_green), Qnil));;
+  int int_blue = XFIXNUM (Ftruncate (make_float (term_blue), Qnil));;
+  XColor color;
+  color.red = int_red;
+  color.green = int_green;
+  color.blue = int_blue;
+  /* `x_alloc_nearest_color' sets the `color.pixel`. */
+  x_alloc_nearest_color (f, cmap, &color);
+  switch (cursor_type)
+  {
+    case HOLLOW_BOX_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          struct face *default_face = FACE_FROM_ID (f, DEFAULT_FACE_ID);
+          Lisp_Object buf = w->contents;
+          CHECK_BUFFER (buf);
+          struct buffer *b = XBUFFER (buf);
+          bool region_active_p = (!NILP (Vtransient_mark_mode)
+                                  && !NILP (BVAR (b, mark_active)));
+          ptrdiff_t region_beginning = (region_active_p) ? XFIXNUM (Fregion_beginning ()) : -1;
+          ptrdiff_t region_end = (region_active_p) ? XFIXNUM (Fregion_end ()) : -1;
+          bool region_in_bounds_p = (region_active_p
+                                     && w->mc.posint >= region_beginning
+                                     && w->mc.posint < region_end);
+          /* Temporarily hijack `f->output_data.x->cursor_gc' by borrowing the
+          functionality of `x_make_gc' in xfns.c.  */
+          if (region_active_p
+              && region_in_bounds_p
+              && active_p)
+            {
+              enum face_id hollow_active_region_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+              struct face *hollow_active_region_face = FACE_FROM_ID (f, hollow_active_region_face_id);
+              XSetForeground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, default_face->foreground);
+              XSetBackground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, hollow_active_region_face->background);
+            }
+            else if (region_active_p
+                     && !region_in_bounds_p
+                     && active_p)
+              {
+                enum face_id hollow_active_region_out_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+                struct face *hollow_active_region_out_face = FACE_FROM_ID (f, hollow_active_region_out_face_id);
+                XSetForeground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, default_face->foreground);
+                XSetBackground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, hollow_active_region_out_face->foreground);
+              }
+              else if (!region_active_p && active_p)
+                {
+                  enum face_id hollow_active_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-face"), true);
+                  struct face *hollow_active_face = FACE_FROM_ID (f, hollow_active_face_id);
+                  XSetForeground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, default_face->foreground);
+                  XSetBackground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, hollow_active_face->background);
+                }
+                /* The region is _not_ visible in the inactive window because the overlay window property is used. */
+                else if (!active_p)
+                  {
+                    enum face_id hollow_inactive_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-inactive-face"), true);
+                    struct face *hollow_inactive_face = FACE_FROM_ID (f, hollow_inactive_face_id);
+                    XSetForeground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, default_face->foreground);
+                    XSetBackground (FRAME_X_DISPLAY (f), f->output_data.x->cursor_gc, hollow_inactive_face->background);
+                  }
+          block_input ();
+          /* Force `x_set_cursor_gc' to use `s->f->output_data.x->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          f->output_data.x->cursor_gc = original_cursor_gc;
+          unblock_input ();
+          /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+          f->output_data.x->cursor_pixel = color.pixel;
+          x_draw_hollow_cursor (w, glyph_row);
+          f->output_data.x->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_hollow_cursor (w, glyph_row);
+      break;
+    }
+    case FILLED_BOX_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        /* Temporarily hijack `f->output_data.x->cursor_gc' by borrowing the
+        functionality of `x_make_gc' in xfns.c.  */
+        {
+          block_input ();
+          XGCValues gc_values;
+          unsigned long mask = GCForeground | GCBackground | GCFillStyle | GCLineWidth;
+          gc_values.line_width = 0;  /* Means 1 using fast algorithm.  */
+          gc_values.foreground = FRAME_BACKGROUND_PIXEL (f);
+          gc_values.background = x_make_truecolor_pixel (dpyinfo, int_red, int_green, int_blue);
+          gc_values.fill_style = FillOpaqueStippled;
+          f->output_data.x->cursor_gc = XCreateGC (FRAME_X_DISPLAY (f), FRAME_X_WINDOW (f), mask, &gc_values);
+          /* Force `x_set_cursor_gc' to use `s->f->output_data.x->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          f->output_data.x->cursor_gc = original_cursor_gc;
+          unblock_input ();
+        }
+        else
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+      break;
+    }
+    case BAR_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+          f->output_data.x->cursor_pixel = color.pixel;
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.x->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+      break;
+    }
+    case HBAR_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+          f->output_data.x->cursor_pixel = color.pixel;
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.x->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+      break;
+    }
+    case NO_CURSOR:
+      w->phys_cursor_width = 0;
+      break;
+    default:
+      emacs_abort ();
+  }
+
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
 
-	    case NO_CURSOR:
-	      w->phys_cursor_width = 0;
-	      break;
 
-	    default:
-	      emacs_abort ();
-	    }
 	}
 
 #ifdef HAVE_X_I18N
